Now compatible with Mistlands!

This mod **greatly improves multiplayer performance.** If you find this mod works as advertised, please endorse it!

**Default settings should be fine for most people.**

_Keep in mind_

* Compression only works between computers with Better Networking.
* Likely incompatible with (and better than) other networking mods.
* Dedicated servers will not apply changes until restarted.
* You must use the join code or *external* IP when connecting to servers on the same network when using crossplay.

_Features_

* crossplay enabled: improves compression speed by more than ~8000% (yes) and compression ratio by up to ~50%!
* crossplay disabled: adds network compression
* allows forcing crossplay (enabled by default)
* package queueing, changing network update speed, min/max send rates, queue size, and network buffer size in Steamworks (AKA crossplay disabled)

_Better Networking links_

* Please [provide feedback!](https://www.nexusmods.com/valheim/mods/1570?tab=posts)
* Please [report bugs!](https://www.nexusmods.com/valheim/mods/1570?tab=bugs)
* Please [endorse on Nexus Mods!](https://www.nexusmods.com/valheim/mods/1570)
* Please [endorse on ThunderStore!](https://valheim.thunderstore.io/package/CW_Jesse/BetterNetworking_Valheim/)

_Educational links_

* [Technical explanation of Valheim's networking](https://redd.it/mga1iw) by u/SleepMyLittleOnes
* [Discussion on desync/lag in Valheim](https://jamesachambers.com/revisiting-fixing-valheim-lag-modifying-send-receive-limits/#comment-11709) on the blog of James A. Chambers

_Special thanks_

* nightshade221 (Max) for being a patron and providing a community!
* Frostsorrow for QA and community assistance!
* Tquilarius for being a patron!
* QA testers: Tatsuya009, Alexander3054, Dskaggsgv, vi0lation, Ersan191, WhiteDingoX5, xdhara, ImpulsiveMind -- thank you all for testing the Linux server versions!

**If you've benefited from this mod and want to see more features implemented, please endorse it! Or if you're feeling particularly generous, donate here or [on Patreon](https://www.patreon.com/CW_Jesse)!**